unit fTestClntMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComObj, TestSrv_TLB, DB, DBClient, MConnect, SConnect, StdCtrls, ActiveX;

type
  TClnt = class(TAutoIntfObject, ITestClntCallback)
  protected
    FOwner: TComponent;
    procedure Progress(percent: Single; out Stop: WordBool); safecall;
    procedure Done; safecall;
    procedure Stopped; safecall;
  public
    constructor Create(AOwner: TComponent; const TypeLib: ITypeLib; const DispIntf: TGUID);
  end;

  TfrmTestClntMain = class(TForm)
    SocketConnection1: TSocketConnection;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    FClnt: TClnt;
    FDuringAction: Boolean;
  public
  end;

var
  frmTestClntMain: TfrmTestClntMain;

implementation

{$R *.dfm}

{ TClnt }

constructor TClnt.Create(AOwner: TComponent; const TypeLib: ITypeLib; const DispIntf: TGUID);
begin
  inherited Create(TypeLib,DispIntf);
  FOwner := AOwner;
end;

procedure TClnt.Done;
begin
  ShowMessage('Done');
end;

procedure TClnt.Stopped;
begin
  ShowMessage('Stopped');
end;

procedure TClnt.Progress(percent: Single; out Stop: WordBool);
begin
  with TfrmTestClntMain(FOwner) do
  begin
    Label1.Caption := '';
    Stop := CheckBox1.Checked;
    Label1.Caption := Format('%.2f%%',[percent]);
    Label1.Update;
  end;
  Application.ProcessMessages;
end;

{ TfrmTestClntMain }

procedure TfrmTestClntMain.Button1Click(Sender: TObject);
  procedure OnOffButtons(IsEnabled: Boolean);
  begin
    Button1.Enabled := IsEnabled;
    Button2.Enabled := IsEnabled;
  end;
begin
  FDuringAction := True;
  try
    OnOffButtons(False);
    case TComponent(Sender).Tag of
      1001: SocketConnection1.AppServer.TEST1;
      1002: SocketConnection1.AppServer.TEST2;
    end;
  finally
    OnOffButtons(True);
    FDuringAction := False;
  end;
  CheckBox1.Checked := False;
end;

procedure TfrmTestClntMain.FormCreate(Sender: TObject);
var
  typelib: ITypeLib;
begin
  Button1.Tag := 1001;
  Button2.Tag := 1002;
  SocketConnection1.Open;
  OleCheck(LoadRegTypeLib(LIBID_TestSrv,1,0,0,typelib));
  FClnt := TClnt.Create(Self,typelib,ITestClntCallback);
  SocketConnection1.AppServer.SetCallback(FClnt as IDispatch);
end;

procedure TfrmTestClntMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := not FDuringAction;
  if CanClose then
  begin
    SocketConnection1.Close;
  end;
end;

end.


